commit 37d026f04c81794aad8ea7fee821062a102df561
Author: freddy77 <freddy77>
Date:   Wed May 28 20:08:48 2008 +0000

    fix minor memory leaks

diff --git a/ChangeLog b/ChangeLog
index dc9ff25..3a2af23 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed May 28 22:08:36 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/apps/freebcp.c src/apps/tsql.c:
+	- fix minor memory leaks
+
 Wed May 28 09:41:16 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* configure.ac src/apps/tsql.c  
 	- reset getopt(3) portably
@@ -313,4 +317,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2527 2008/05/28 13:44:19 jklowden Exp $
+$Id: ChangeLog,v 1.2528 2008/05/28 20:08:48 freddy77 Exp $
diff --git a/src/apps/freebcp.c b/src/apps/freebcp.c
index 0cc051f..86d9a2b 100644
--- a/src/apps/freebcp.c
+++ b/src/apps/freebcp.c
@@ -45,7 +45,7 @@
 #include <sybdb.h>
 #include "freebcp.h"
 
-static char software_version[] = "$Id: freebcp.c,v 1.48 2006/12/01 21:51:11 jklowden Exp $";
+static char software_version[] = "$Id: freebcp.c,v 1.49 2008/05/28 20:08:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void pusage(void);
@@ -351,6 +351,8 @@ login_to_database(BCPPARAMDATA * pdata, DBPROCESS ** pdbproc)
 	 */
 
 	login = dblogin();
+	if (!login)
+		return FALSE;
 
 	DBSETLUSER(login, pdata->user);
 	DBSETLPWD(login, pdata->pass);
@@ -372,8 +374,11 @@ login_to_database(BCPPARAMDATA * pdata, DBPROCESS ** pdbproc)
 
 	if ((*pdbproc = dbopen(login, pdata->server)) == NULL) {
 		fprintf(stderr, "Can't connect to server \"%s\".\n", pdata->server);
+		dbloginfree(login);
 		return (FALSE);
 	}
+	dbloginfree(login);
+	login = NULL;
 
 	/* set hint if any */
 	if (pdata->hint) {
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index cb4ae36..edb1c08 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.116 2008/05/28 13:44:19 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.117 2008/05/28 20:08:48 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -407,24 +407,24 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 			opt_flags_str = optarg;
 			break;
 		case 'H':
-			hostname = (char *) malloc(strlen(optarg) + 1);
-			strcpy(hostname, optarg);
+			free(hostname);
+			hostname = strdup(optarg);
 			break;
 		case 'S':
-			servername = (char *) malloc(strlen(optarg) + 1);
-			strcpy(servername, optarg);
+			free(servername);
+			servername = strdup(optarg);
 			break;
 		case 'U':
-			username = (char *) malloc(strlen(optarg) + 1);
-			strcpy(username, optarg);
+			free(username);
+			username = strdup(optarg);
 			break;
 		case 'P':
-			password = (char *) malloc(strlen(optarg) + 1);
-			strcpy(password, optarg);
+			free(password);
+			password = strdup(optarg);
 			break;
 		case 'I':
-			confile = (char *) malloc(strlen(optarg) + 1);
-			strcpy(confile, optarg);
+			free(confile);
+			confile = strdup(optarg);
 			break;
 		case 'p':
 			port = atoi(optarg);

